package Db::MysqlDbiBackend;

use strict;
use Db::DbiBackend;
use Db::MysqlUtils;

use vars qw|@ISA|;

@ISA = qw|Db::DbiBackend|;

sub _init {
  my ($self, %params) = @_;

  $self->SUPER::_init(%params, 'type'=>'mysql');
}

sub connect {
  my ($self) = @_;

  return if !($self->SUPER::connect());

  if (Db::MysqlUtils::doesSupportCharacterSets($self)) {
    $self->execute(Db::MysqlUtils::getCharacterSetsSupportSql());
    $self->execute(Db::MysqlUtils::getNamesCharacterSetsSupportSql());
  }

  return 1;
}

sub execute {
  my ($self, $sql) = @_;

  my $res = $self->SUPER::execute($sql);

  return $res if $res;

  #
  # Reconnect on timeout
  #
  Logging::warning("Timeout occured during mysql query. Reconnecting.");
  $self->{dbh}->disconnect();
  die if !$self->connect();

  return $self->SUPER::execute($sql);
}

1;
